/***************************************************************************
                          cmapper.h
                      -------------------
    description          : Auto Mapper Window Class
    begin                : Tue Oct 19 1999                                           
    copyright            : (C) 1999 by John-Paul Stanford                      
    email                : john-paul.stanford@virgin.net                       
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef CMAPWINDOW_H
#define CMAPWINDOW_H

#include <ktmainwindow.h>
#include <kaccel.h>
#include <kiconloader.h>
#include <kapp.h>

#include "cmapwidget.h"
#include "resource.h"

/**The Auto Mapper Window Class
  *@author John-Paul Stanford
  */

class CMapWindow : public KTMainWindow
{
   Q_OBJECT
public:
	/** Constructor */
	CMapWindow();
	/** Destructor */
	~CMapWindow();

	/** Setup the menu bar */
	void initMenubar(void);
	/** Setup the status bar */
	void initStatusBar(void);
	/** Used to read the mappers options */
	void readOptions(void);
	/** Used to save the mappers options */
	void saveOptions(void);

private:
	/** The mapper windows width */
	int mapperWindowWidth;
	/** The mapper windows height */
	int mapperWindowHeight;
	/** Hold the position of the mapper menu bar */
	KMenuBar::menuPosition menu_bar_pos;
	/** flag if statusbar is visible or not. */
	bool bViewStatusbar;
	/** The options menu */
	QPopupMenu *file_menu;
	/** The scroll view widget used to display the map */
	CMapWidget *map;

public slots:
	/** switch argument for slot selection by menu or toolbar ID */
	void commandCallback(int id_);
	/** switch argument for Statusbar help entries on slot selection */
	void statusCallback(int id_);
	/** close the map window */
	void slotFileCloseWindow();
	/** export the map to a different format */
	void slotFileExport();
	/** change the status message to text */
	void slotStatusMsg(const char *text);
	/** change the status message of the whole statusbar temporary */
	void slotStatusHelpMsg(const char *text);

};

#endif
