/***************************************************************************
                          cmudprofile.cpp
                        -------------------
    description          : Mud Profile Class
    begin                : Sun Oct 17 1999
    copyright            : (C) 1999 by Stephan Uhlmann
    email                : suhlmann@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmudprofile.h"

CMudProfile::CMudProfile(){
 filename="";
 title="";
 hostname="";
 port=23;
 iType=0;
}
CMudProfile::~CMudProfile(){
}

QString CMudProfile::getFileName()
{ return filename; }

void CMudProfile::setFileName(QString f)
{ filename=f; }


QString CMudProfile::getTitle()
{ return title; }

void CMudProfile::setTitle(QString t)
{ title=t; }

QString CMudProfile::getHostName()
{ return hostname; }

void CMudProfile::setHostName(QString h)
{ hostname=h; }

unsigned int CMudProfile::getPort()
{ return port; }

void CMudProfile::setPort(unsigned int p)
{ port=p; }


void CMudProfile::readData()
{
 KSimpleConfig mudconf(QDir::homeDirPath()+"/.kde/share/apps/kmud/muds/"+filename);

 title=mudconf.readEntry("Title","");
 hostname=mudconf.readEntry("Hostname","");
 port=mudconf.readNumEntry("Port",23);
 iType=mudconf.readNumEntry("InterpretType",0);
}

void CMudProfile::writeData()
{
 KSimpleConfig mudconf(QDir::homeDirPath()+"/.kde/share/apps/kmud/muds/"+filename);

 mudconf.writeEntry("Title",title);
 mudconf.writeEntry("Hostname",hostname);
 mudconf.writeEntry("Port",port);
 mudconf.writeEntry("InterpretType",iType);

}

int CMudProfile::getInterpretationType()
{
    return iType;
}

void CMudProfile::setInterpretationType(int i)
{
    iType = i;
}