/***************************************************************************
                          cmudprofile.h
                      -------------------
    description          : Mud Profile Class
    begin                : Sun Oct 17 1999                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef CMUDPROFILE_H
#define CMUDPROFILE_H

#include <qstring.h>
#include <qdir.h>
#include <ksimpleconfig.h>


/**
	* Mud Profile Class
  *@author Stephan Uhlmann
  */

class CMudProfile {
public:
	/** constructor */
	CMudProfile();
	/** destructor */
	~CMudProfile();

	/** returns the filename where the data are stored */
	QString getFileName();
	/** sets the filename where the data are stored */
	void setFileName(QString);

	/** returns the title */
	QString getTitle();
	/** sets the title */
	void setTitle(QString);

	/** returns the hostname */
	QString getHostName();
	/** sets the hostname */
	void setHostName(QString);

	/** returns the port */
	unsigned int getPort();
	/** sets the port */
	void setPort(unsigned int);

	/** reads the data of the class from its file */
	void readData();
	/** writes the data to the class to its file */
	void writeData();

	/** returns iType (the interpretation type) */
	int getInterpretationType();
	/** sets the interpretation type */
	void setInterpretationType(int i);

private:
	QString filename;
	QString title;
	QString hostname;
	unsigned int port;
	/** The interpretation type */
	int iType;

};

#endif
