/***************************************************************************
                          dlgconnectionwizard.h
                           -------------------
    description          : Connection Wizard Dialog Class
    begin                : Sun Oct 17 1999                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DLGCONNECTIONWIZARD_H
#define DLGCONNECTIONWIZARD_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>
#include <qregexp.h>
//#include <qfiledialog.h>
#include <qfileinfo.h>

#include <kapp.h>
#include "kmuddoc.h"
#include "dlgselectmud.h"
#include "dlgselectprofile.h"

/**
	* Connection Wizard Dialog Class
  *@author Stephan Uhlmann
  */

class DlgConnectionWizard : public QDialog  {
   Q_OBJECT
public:
  /** constructor */
	DlgConnectionWizard( KmudDoc* document, QWidget *parent=0, const char *name=0);
  /** destructor */
	~DlgConnectionWizard();

  /** returns the entered login name */
	QString getLogin();
  /** returns the entered mud title */
	QString getMudTitle();
  /** returns the entered mud host */
	QString getMudHost();
  /** returns the entered mud port */
	QString getMudPort();

	QString getCharacterID();
	QString getMudID();


public slots:
	void slotConnectPressed();
	void slotOKPressed();
	void slotCancelPressed();
	void slotNewPressed();
	void slotDeletePressed();
	void slotSelectMudPressed();
  void slotSelectProfilePressed();

	void slotShowItem(QListViewItem*);

	void slotChangedLogin(const char*);
  void slotChangedMudTitle(const char*);

protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QPushButton *connect_Button;
	QPushButton *cancel_Button;
	QGroupBox *character_GroupBox;
	QLabel *login_Label;
	QLineEdit *login_LineEdit;
	QGroupBox *mud_GroupBox;
	QLabel *mudTitle_Label;
	QLineEdit *mudTitle_LineEdit;
	QPushButton *mudListSelect_Button;
	QLabel *mudHost_Label;
	QLineEdit *mudHost_LineEdit;
	QLabel *mudPort_Label;
	QLineEdit *mudPort_LineEdit;
	QPushButton *new_Button;
	QPushButton *delete_Button;
	QListView *charDB_ListView;
	QPushButton *ok_Button;
	QLabel *charProfile_Label;
	QLabel *charProfileShow_Label;
	QPushButton *charProfileSelect_Button;
	//Generated area. DO NOT EDIT!!!(end)

private:

	void updateListView();
	void applyInputTo(QListViewItem*);
  void setDialogState();

	KmudDoc* doc;

	QListViewItem* saveItem;

};

#endif
