/***************************************************************************
                          dlgoptioncolors.cpp
                          -------------------
    description          : Color Options Dialog Class
    begin                : Mon Sep 20 1999
    copyright            : (C) 1999 by Stephan Uhlmann
    email                : suhlmann@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "dlgoptioncolors.h"

DlgOptionColors::DlgOptionColors(QWidget *parent, const char *name, int i) : QDialog(parent,name,true){

    iType = i;	
    initDialog();
    slotInterpretType();

    connect( ok_Button, SIGNAL(clicked()), SLOT(accept()) );
    connect( cancel_Button, SIGNAL(clicked()), SLOT(reject()) );
    connect( defaults_Button, SIGNAL(clicked()), SLOT(slotDefaults()) );
    connect( Reverse_Button, SIGNAL(clicked()), SLOT(slotReverse()) );
}

DlgOptionColors::~DlgOptionColors(){

	// no need to delete widgets that are children of this class
	// since they will be destroyed when destroying the parent
	// see: ~QObject()
}


QColor DlgOptionColors::getForegroundColor()
{
 return foreground_KColorButton->color();
}

QColor DlgOptionColors::getBackgroundColor()
{
 return background_KColorButton->color();
}

QColor DlgOptionColors::getLocalEchoColor()
{
 return localEchoColor_KColorButton->color();
}

QColor DlgOptionColors::getDebugHighlightColor()
{
    return debugHighlight_KColorButton->color();
}

// Getting Dark Colors
QColor DlgOptionColors::getANSIBlack()
{
 return ansiBlack_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkRed()
{
 return ansiDarkRed_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkGreen()
{
 return ansiDarkGreen_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkYellow()
{
 return ansiDarkYellow_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkBlue()
{
 return ansiDarkBlue_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkMagenta()
{
 return ansiDarkMagenta_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkCyan()
{
 return ansiDarkCyan_KColorButton->color();
}
QColor DlgOptionColors::getANSIDarkWhite()
{
 return ansiDarkWhite_KColorButton->color();
}

// Getting Light Colors
QColor DlgOptionColors::getANSIGray()
{
 return ansiGray_KColorButton->color();
}
QColor DlgOptionColors::getANSILightRed()
{
 return ansiLightRed_KColorButton->color();
}
QColor DlgOptionColors::getANSILightGreen()
{
 return ansiLightGreen_KColorButton->color();
}
QColor DlgOptionColors::getANSILightYellow()
{
 return ansiLightYellow_KColorButton->color();
}
QColor DlgOptionColors::getANSILightBlue()
{
 return ansiLightBlue_KColorButton->color();
}
QColor DlgOptionColors::getANSILightMagenta()
{
 return ansiLightMagenta_KColorButton->color();
}
QColor DlgOptionColors::getANSILightCyan()
{
 return ansiLightCyan_KColorButton->color();
}
QColor DlgOptionColors::getANSILightWhite()
{
 return ansiLightWhite_KColorButton->color();
}




void DlgOptionColors::setForegroundColor(QColor fgc)
{
  foreground_KColorButton->setColor(fgc);
}

void DlgOptionColors::setBackgroundColor(QColor bgc)
{
  background_KColorButton->setColor(bgc);
}

void DlgOptionColors::setLocalEchoColor(QColor bgc)
{
  localEchoColor_KColorButton->setColor(bgc);
}


void DlgOptionColors::setDebugHighlightColor(QColor color)
{
    debugHighlight_KColorButton->setColor(color);
}


void DlgOptionColors::setANSIBlack(QColor fgc)
{
  ansiBlack_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkRed(QColor fgc)
{
  ansiDarkRed_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkGreen(QColor fgc)
{
  ansiDarkGreen_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkYellow(QColor fgc)
{
  ansiDarkYellow_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkBlue(QColor fgc)
{
  ansiDarkBlue_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkMagenta(QColor fgc)
{
  ansiDarkMagenta_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkCyan(QColor fgc)
{
  ansiDarkCyan_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSIDarkWhite(QColor fgc)
{
  ansiDarkWhite_KColorButton->setColor(fgc);
}

void DlgOptionColors::setANSIGray(QColor fgc)
{
  ansiGray_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightRed(QColor fgc)
{
  ansiLightRed_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightGreen(QColor fgc)
{
  ansiLightGreen_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightYellow(QColor fgc)
{
  ansiLightYellow_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightBlue(QColor fgc)
{
  ansiLightBlue_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightMagenta(QColor fgc)
{
  ansiLightMagenta_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightCyan(QColor fgc)
{
  ansiLightCyan_KColorButton->setColor(fgc);
}
void DlgOptionColors::setANSILightWhite(QColor fgc)
{
  ansiLightWhite_KColorButton->setColor(fgc);
}

/** For background colors (set and get) */
void DlgOptionColors::setBgBlack(QColor c) {
    bgBlack_Color->setColor(c);
}
void DlgOptionColors::setBgRed(QColor c) {
    bgRed_Color->setColor(c);
}
void DlgOptionColors::setBgGreen(QColor c) {
    bgGreen_Color->setColor(c);
}
void DlgOptionColors::setBgYellow(QColor c) {
    bgYellow_Color->setColor(c);
}
void DlgOptionColors::setBgBlue(QColor c) {
    bgBlue_Color->setColor(c);
}
void DlgOptionColors::setBgMagenta(QColor c) {
    bgMagenta_Color->setColor(c);
}
void DlgOptionColors::setBgCyan(QColor c) {
    bgCyan_Color->setColor(c);
}
void DlgOptionColors::setBgWhite(QColor c) {
    bgWhite_Color->setColor(c);
}

/** Gets background colors */
QColor DlgOptionColors::getBgBlack() {
    return bgBlack_Color->color();
}
QColor DlgOptionColors::getBgRed() {
    return bgRed_Color->color();
}
QColor DlgOptionColors::getBgGreen() {
    return bgGreen_Color->color();
}
QColor DlgOptionColors::getBgYellow() {
    return bgYellow_Color->color();
}
QColor DlgOptionColors::getBgBlue() {
    return bgBlue_Color->color();
}
QColor DlgOptionColors::getBgMagenta() {
    return bgMagenta_Color->color();
}
QColor DlgOptionColors::getBgCyan() {
    return bgCyan_Color->color();
}
QColor DlgOptionColors::getBgWhite() {
    return bgWhite_Color->color();
}


void DlgOptionColors::slotDefaults()
{
  ansiBlack_KColorButton->setColor(QColor(0, 0, 0));
  ansiDarkRed_KColorButton->setColor(QColor(128, 0, 0));
  ansiDarkGreen_KColorButton->setColor(QColor(0, 128, 0));
  ansiDarkYellow_KColorButton->setColor(QColor(128, 128, 0));
  ansiDarkBlue_KColorButton->setColor(QColor(0, 0, 128));
  ansiDarkMagenta_KColorButton->setColor(QColor(128, 0, 128));
  ansiDarkCyan_KColorButton->setColor(QColor(0, 128, 128));
  ansiDarkWhite_KColorButton->setColor(QColor(192, 192, 192));
  ansiGray_KColorButton->setColor(QColor(128, 128, 128));
  ansiLightRed_KColorButton->setColor(QColor(255, 0, 0));
  ansiLightGreen_KColorButton->setColor(QColor(0, 255, 0));
  ansiLightYellow_KColorButton->setColor(QColor(255, 255, 0));
  ansiLightBlue_KColorButton->setColor(QColor(0, 0, 255));
  ansiLightMagenta_KColorButton->setColor(QColor(255, 0, 255));
  ansiLightCyan_KColorButton->setColor(QColor(0, 255, 255));
  ansiLightWhite_KColorButton->setColor(QColor(255, 255, 255));

  bgBlack_Color->setColor(QColor(0, 0, 0));
  bgRed_Color->setColor(QColor(128, 0, 0));
  bgGreen_Color->setColor(QColor(0, 128, 0));
  bgYellow_Color->setColor(QColor(128, 128, 0));
  bgBlue_Color->setColor(QColor(0, 0, 128));
  bgMagenta_Color->setColor(QColor(128, 0, 128));
  bgCyan_Color->setColor(QColor(0, 128, 128));
  bgWhite_Color->setColor(QColor(192, 192, 192));
}

void DlgOptionColors::slotReverse()
{
  QColor QGray         = getANSIGray();
  QColor QLightRed     = getANSILightRed();
  QColor QLightGreen   = getANSILightGreen();
  QColor QLightYellow  = getANSILightYellow();
  QColor QLightBlue    = getANSILightBlue();
  QColor QLightMagenta = getANSILightMagenta();
  QColor QLightCyan    = getANSILightCyan();
  QColor QLightWhite   = getANSILightWhite();
  QColor QBlack        = getANSIBlack();
  QColor QDarkRed      = getANSIDarkRed();
  QColor QDarkGreen    = getANSIDarkGreen();
  QColor QDarkYellow   = getANSIDarkYellow();
  QColor QDarkBlue     = getANSIDarkBlue();
  QColor QDarkMagenta  = getANSIDarkMagenta();
  QColor QDarkCyan     = getANSIDarkCyan();
  QColor QDarkWhite    = getANSIDarkWhite();

  ansiBlack_KColorButton->       setColor(QGray);
  ansiDarkRed_KColorButton->     setColor(QLightRed);
  ansiDarkGreen_KColorButton->   setColor(QLightGreen);
  ansiDarkYellow_KColorButton->  setColor(QLightYellow);
  ansiDarkBlue_KColorButton->    setColor(QLightBlue);
  ansiDarkMagenta_KColorButton-> setColor(QLightMagenta);
  ansiDarkCyan_KColorButton->    setColor(QLightCyan);
  ansiDarkWhite_KColorButton->   setColor(QLightWhite);
  ansiGray_KColorButton->        setColor(QBlack);
  ansiLightRed_KColorButton->    setColor(QDarkRed);
  ansiLightGreen_KColorButton->  setColor(QDarkGreen);
  ansiLightYellow_KColorButton-> setColor(QDarkYellow);
  ansiLightBlue_KColorButton->   setColor(QDarkBlue);
  ansiLightMagenta_KColorButton->setColor(QDarkMagenta);
  ansiLightCyan_KColorButton->   setColor(QDarkCyan);
  ansiLightWhite_KColorButton->  setColor(QDarkWhite);
}

void DlgOptionColors::slotInterpretType()
{
  if ((iType== 0) || (iType==1))
  {
    ansiBlack_KColorButton->       setEnabled(true);
    ansiDarkRed_KColorButton->     setEnabled(true);
    ansiDarkGreen_KColorButton->   setEnabled(true);
    ansiDarkYellow_KColorButton->  setEnabled(true);
    ansiDarkBlue_KColorButton->    setEnabled(true);
    ansiDarkMagenta_KColorButton-> setEnabled(true);
    ansiDarkCyan_KColorButton->    setEnabled(true);
    ansiDarkWhite_KColorButton->   setEnabled(true);
    ansiGray_KColorButton->        setEnabled(true);
    ansiLightRed_KColorButton->    setEnabled(true);
    ansiLightGreen_KColorButton->  setEnabled(true);
    ansiLightYellow_KColorButton-> setEnabled(true);
    ansiLightBlue_KColorButton->   setEnabled(true);
    ansiLightMagenta_KColorButton->setEnabled(true);
    ansiLightCyan_KColorButton->   setEnabled(true);
    ansiLightWhite_KColorButton->  setEnabled(true);
    bgBlack_Color       ->setEnabled(true);
    bgRed_Color         ->setEnabled(true);
    bgGreen_Color       ->setEnabled(true);
    bgYellow_Color      ->setEnabled(true);
    bgBlue_Color        ->setEnabled(true);
    bgMagenta_Color     ->setEnabled(true);
    bgCyan_Color        ->setEnabled(true);
    bgWhite_Color       ->setEnabled(true);

    black_Label         ->setEnabled(true);
    darkRed_Label       ->setEnabled(true);
    darkGreen_Label     ->setEnabled(true);
    darkYellowD_Label   ->setEnabled(true);
    darkBlue_Label      ->setEnabled(true);
    darkMagenta_Label   ->setEnabled(true);
    darkCyan_Label      ->setEnabled(true);
    darkWhite_Label     ->setEnabled(true);
    gray_Label          ->setEnabled(true);
    lightRed_Label      ->setEnabled(true);
    lightGreen_Label    ->setEnabled(true);
    lightYellow_Label   ->setEnabled(true);
    lightBlue_Label     ->setEnabled(true);
    lightMagenta_Label  ->setEnabled(true);
    lightCyan_Label     ->setEnabled(true);
    lightWhite_Label    ->setEnabled(true);
    bgBlack_Label       ->setEnabled(true);
    bgRed_Label         ->setEnabled(true);
    bgGreen_Label       ->setEnabled(true);
    bgYellow_Label      ->setEnabled(true);
    bgBlue_Label        ->setEnabled(true);
    bgMagenta_Label     ->setEnabled(true);
    bgCyan_Label        ->setEnabled(true);
    bgWhite_Label       ->setEnabled(true);

    defaults_Button->setEnabled(true);
    Reverse_Button->setEnabled(true);
  }
  else
  {
    ansiBlack_KColorButton->       setEnabled(false);
    ansiDarkRed_KColorButton->     setEnabled(false);
    ansiDarkGreen_KColorButton->   setEnabled(false);
    ansiDarkYellow_KColorButton->  setEnabled(false);
    ansiDarkBlue_KColorButton->    setEnabled(false);
    ansiDarkMagenta_KColorButton-> setEnabled(false);
    ansiDarkCyan_KColorButton->    setEnabled(false);
    ansiDarkWhite_KColorButton->   setEnabled(false);
    ansiGray_KColorButton->        setEnabled(false);
    ansiLightRed_KColorButton->    setEnabled(false);
    ansiLightGreen_KColorButton->  setEnabled(false);
    ansiLightYellow_KColorButton-> setEnabled(false);
    ansiLightBlue_KColorButton->   setEnabled(false);
    ansiLightMagenta_KColorButton->setEnabled(false);
    ansiLightCyan_KColorButton->   setEnabled(false);
    ansiLightWhite_KColorButton->  setEnabled(false);
    bgBlack_Color       ->setEnabled(false);
    bgRed_Color         ->setEnabled(false);
    bgGreen_Color       ->setEnabled(false);
    bgYellow_Color      ->setEnabled(false);
    bgBlue_Color        ->setEnabled(false);
    bgMagenta_Color     ->setEnabled(false);
    bgCyan_Color        ->setEnabled(false);
    bgWhite_Color       ->setEnabled(false);

    black_Label         ->setEnabled(false);
    darkRed_Label       ->setEnabled(false);
    darkGreen_Label     ->setEnabled(false);
    darkYellowD_Label   ->setEnabled(false);
    darkBlue_Label      ->setEnabled(false);
    darkMagenta_Label   ->setEnabled(false);
    darkCyan_Label      ->setEnabled(false);
    darkWhite_Label     ->setEnabled(false);
    gray_Label          ->setEnabled(false);
    lightRed_Label      ->setEnabled(false);
    lightGreen_Label    ->setEnabled(false);
    lightYellow_Label   ->setEnabled(false);
    lightBlue_Label     ->setEnabled(false);
    lightMagenta_Label  ->setEnabled(false);
    lightCyan_Label     ->setEnabled(false);
    lightWhite_Label    ->setEnabled(false);
    bgBlack_Label       ->setEnabled(false);
    bgRed_Label         ->setEnabled(false);
    bgGreen_Label       ->setEnabled(false);
    bgYellow_Label      ->setEnabled(false);
    bgBlue_Label        ->setEnabled(false);
    bgMagenta_Label     ->setEnabled(false);
    bgCyan_Label        ->setEnabled(false);
    bgWhite_Label       ->setEnabled(false);

    defaults_Button->setEnabled(false);
    Reverse_Button->setEnabled(false);
  }
}