/***************************************************************************
                          dlgoptiongeneral.h
                          -------------------
    description          : General Options Dialog Class
    begin                : Thu Oct 7 1999
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DLGOPTIONGENERAL_H
#define DLGOPTIONGENERAL_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>

/**
	* General Options Dialog Class
  *@author Stephan Uhlmann
  */

class DlgOptionGeneral : public QDialog  {
   Q_OBJECT
public: 
	/** constructor */
	DlgOptionGeneral(QWidget *parent=0, const char *name=0);
	/** destructor */
	~DlgOptionGeneral();

	/** checks/unchecks QCkeckBox for keepLastInput option */
  void setAutoReconnect(bool);
	/** returns the value of the QCheckBox for keepLastInput option */
  bool getAutoReconnect();
	/** checks/unchecks QCkeckBox for autoReconnect option */
  void setKeepLastInput(bool);
	/** returns the value of the QCheckBox for autoReconnect option */
  bool getKeepLastInput();
  /** Returns the separator character */
  QString getSeparator();
  /** Sets the separator character */
  void setSeparator(QString s);
  /** checks/unchecks useBeep */
  void setUseBeep(bool u);
  /** gets status of useBeep */
  bool getUseBeep();

protected: 
	/** initalizes Dialog (KDevelop generated) */
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QCheckBox *keepLastInput_CheckBox;
	QCheckBox *autoReconnect_CheckBox;
	QGroupBox *charCust_GroupBox;
	QLabel *QLabel_4;
	QLineEdit *separator_LineEdit;
	QCheckBox *useBeep_CheckBox;
	//Generated area. DO NOT EDIT!!!(end)

private:
    /** The separator character */
    QString separator;
};

#endif






