/***************************************************************************
                          dlgprofilemacros.cpp
                      -------------------
    description          : Defines Macros
    begin                : Sun Nov 14 1999                                           
    copyright            : (C) 1999 by Luke Ehresman
    email                : luke@usa.om.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "dlgprofilemacros.h"
#include <qmessagebox.h>

DlgProfileMacros::DlgProfileMacros(CCharacterProfile* prof, AliasEntry* a, QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();

	profile = prof;
	alias = a;
	
	connect( none_Button, SIGNAL(clicked()), SLOT(slotNone()) );	
	connect( cancel_Button, SIGNAL(clicked()), SLOT(reject()) );
	connect( ok_Button, SIGNAL(clicked()), SLOT(accept()) );
}

DlgProfileMacros::~DlgProfileMacros(){
}

/** When NONE is pressed */
void DlgProfileMacros::slotNone() {
    alias->macro = 0;
    accept();
}

void DlgProfileMacros::keyPressEvent( QKeyEvent* e )
{
    AliasEntry *tmpAlias;
    tmpAlias = profile->firstAlias();

    while (tmpAlias != NULL)
    {
        if ((tmpAlias->name != alias->name) && (e->key() == tmpAlias->macro))
        {
            switch ( QMessageBox::warning(this,
                                          "ERROR",
                                          "That macro is already defined by\n \""+ tmpAlias->name +"\".  Redefine this macro?",
                                          QMessageBox::Yes,
                                          QMessageBox::No | QMessageBox::Escape ))
            {
                case QMessageBox::Yes:
                            tmpAlias->macro = 0;
                            break;
                case QMessageBox::No:
                            return;
            }
        }
        tmpAlias = profile->nextAlias();
    }

    switch( e->key() ) {
//        case Key_F1:
//            QLabel_6->setText("Key: F1");
//            break;
        case Key_F2:
            alias->macro = Key_F2;
            accept();
            break;
        case Key_F3:
            alias->macro = Key_F3;
            accept();
            break;
        case Key_F4:
            alias->macro = Key_F4;
            accept();
            break;
        case Key_F5:
            alias->macro = Key_F5;
            accept();
            break;
        case Key_F6:
            alias->macro = Key_F6;
            accept();
            break;
        case Key_F7:
            alias->macro = Key_F7;
            accept();
            break;
        case Key_F8:
            alias->macro = Key_F8;
            accept();
            break;
        case Key_F9:
            alias->macro = Key_F9;
            accept();
            break;
        case Key_F10:
            alias->macro = Key_F10;
            accept();
            break;
        case Key_F11:
            alias->macro = Key_F11;
            accept();
            break;
        case Key_F12:
            alias->macro = Key_F12;
            accept();
            break;
        default:
            e->ignore();
  }
}
