/***************************************************************************
                          dlgreconnect.cpp
                      -------------------
    description          :
    begin                : Fri Oct 29 1999                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
                          dlgreconnect.cpp
                      -------------------
    description          :
    begin                : Sun Oct 24 1999                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "dlgreconnect.h"

DlgReconnect::DlgReconnect(QWidget *parent, const char *name) : QDialog(parent,name,true)
{
	initDialog();
	connect( cmdReconnect, SIGNAL(clicked()), SLOT(slotReconnectPressed()) );
	connect( cmdCancel, SIGNAL(clicked()), SLOT(reject()) );

	seconds = 10;

	QTimer *timer = new QTimer( this );
	connect( timer, SIGNAL(timeout()),this, SLOT(slotTimerDone()) );
	timer->start( 1000, false );                 // 2 seconds single-shot


}

DlgReconnect::~DlgReconnect()
{
}

/** This slot is called when the reconnect button is pressed */
void DlgReconnect::slotReconnectPressed()
{
 	accept();
}

/** This slot is called when the cancel button is pressed */
void DlgReconnect::slotCancelPressed()
{
	reject();
}

/** This slot is called to up date the seconds count on the dialog */
void DlgReconnect::slotTimerDone()
{
	QString time_string;
	seconds--;
	if (seconds == 0)
	{
			timer->stop();
			accept();
	}
	else
	{
		time_string.sprintf("Auto reconnect in %d seconds",seconds);
		QLabel_4->setText(time_string);	
	}
}





