/***************************************************************************
                          main.cpp  -  description                              
                             -------------------                                         
    begin                : Sun Jun 20 14:17:54 MEST 1999
                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "kmud.h"

void HelpMsg(void)
{
	printf("Please visit http://fara.cs.uni-potsdam.de/~uhlmann/kmud/ for the latest version and other information.\n\n");
	printf("kmud [--help | --version | --host <host> --port <port> | \n");
  printf("      --wizard <character@mud title> ]\n\n");
	printf("Options:\n");
	printf("-h, --help                   Show this help.\n");
	printf("-v, --version                Show kmud version\n");
	printf("-h <host>, --host <host>     Connect to specified host\n");
	printf("-p <port>, --port <port>     Connect to specified port\n");
	printf("-w , --wizard                 Connect to specified mud wizard entry\n\n");
	printf("Examples:\n");
	printf("   kmud -w \"Sunbright@Midnight Sun\"\n");
	printf("   kmud --wizard Sunbright@WOW\n");
	printf("   kmud --host midnight-sun.ludd.luth.se --port 3000\n\n");
}

int main(int argc, char* argv[]) {
  KApplication app(argc,argv,"kmud");

	// Deal with CLI information parameters

	// Check to see if there are any parameters
	if (app.argc()>1)
	{
		// Check to see that the given parameter is valid
		if (strcmp(app.argv()[1],"--version") &&
			  strcmp(app.argv()[1],"--host") &&
				strcmp(app.argv()[1],"--port") &&
				strcmp(app.argv()[1],"--wizard") &&
				strcmp(app.argv()[1],"--help") &&
				strcmp(app.argv()[1],"-v") &&
				strcmp(app.argv()[1],"-h") &&
			  strcmp(app.argv()[1],"-p") &&
				strcmp(app.argv()[1],"-w") &&
				strcmp(app.argv()[1],"-h"))
		{
			printf("Invalid Parameters!\n");
			HelpMsg();
			return 0;
		}

		if (!strcmp(app.argv()[1],"--version") || !strcmp(app.argv()[1],"-v"))
		{
			printf("\nKMud Version 0.2\n\n");
			return 0;			
		}

		if ((!strcmp(app.argv()[1],"--help") || !strcmp(app.argv()[1],"-h")) && app.argc()==2)
		{
			HelpMsg();
			return 0;
		}
	}

  if (app.isRestored())
  {
			RESTORE(KmudApp);
  }
  else
    {
      KmudApp* kmud = new KmudApp;

			// Check to see if any CLI parameters have been given
			if (app.argc()>1)
			{
				if ((!strcmp(app.argv()[1],"--host") || !strcmp(app.argv()[1],"-h")) && app.argc()>2)
				{
					if ((!strcmp(app.argv()[3],"--port") || !strcmp(app.argv()[3],"-p")) && app.argc()==5)
					{
						kmud->connectToMud("","",app.argv()[2],app.argv()[4]);
					}
					else
					{
						kmud->connectToMud("","",app.argv()[2],"23");
					}
				}

				if ((!strcmp(app.argv()[1],"--port") || !strcmp(app.argv()[1],"-p")) && app.argc()==5)
				{
				  if (!strcmp(app.argv()[3],"--host") || !strcmp(app.argv()[3],"-h"))
						kmud->connectToMud("","",app.argv()[4],app.argv()[2]);
					else
					{
						printf("Invalid Parameters!\n");
						HelpMsg();
						return 0;
					}
				}

				if (!strcmp(app.argv()[1],"--wizard") || !strcmp(app.argv()[1],"-w"))
				{
					if (app.argc()==3)
						kmud->connectWizzardId(app.argv()[2]);	
					else
					{
						printf("Invalid Parameters!\n");
						HelpMsg();
						return 0;
					}
				}
			}

      kmud->show();
    }
  return app.exec();
}






