/***************************************************************************
                          resource.h  -  description                              
                             -------------------                                         
    begin                : Sun Jun 20 14:17:54 MEST 1999
                                           
    copyright            : (C) 1999 by Stephan Uhlmann                         
    email                : suhlmann@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef RESSOURCE_H
#define RESSOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands

///////////////////////////////////////////////////////////////////
// COMMAND VALUES FOR MENUBAR AND TOOLBAR ENTRIES


///////////////////////////////////////////////////////////////////
// File-menu entries
#define ID_MUD_NEW_WINDOW          10010
#define ID_MUD_CONNECTION_WIZARD   10020
#define ID_MUD_CONNECT             10030
#define ID_MUD_CLOSE               10070


#define ID_MUD_CLOSE_WINDOW        10090
#define ID_MUD_QUIT                10100



///////////////////////////////////////////////////////////////////
// View-menu entries                    
#define ID_VIEW_TOOLBAR             12010
#define ID_VIEW_STATUSBAR           12020
#define ID_VIEW_OPTIONS             12030
#define ID_VIEW_ALTINPUT            12040
#define ID_VIEW_MAPPER              12050



///////////////////////////////////////////////////////////////////
// Option-menu entries
#define ID_OPTION_FONT             13010
#define ID_OPTION_COLORS           13020
#define ID_OPTION_PREFERENCES      13030
#define ID_OPTION_MUD              13040
#define ID_OPTION_SAVE             13100

///////////////////////////////////////////////////////////////////
// Profile-menu entries
#define ID_PROFILE_ALIASES         14010
#define ID_PROFILE_TRIGGERS        14020
#define ID_PROFILE_SAVE            14100


///////////////////////////////////////////////////////////////////
// Help-menu entries
#define ID_HELP                     1002

///////////////////////////////////////////////////////////////////
// General application values
#define ID_STATUS_MSG               1001
#define ID_STATUS_ICON              1002
#define ID_STATUS_TIME              1003


//////////////////////////////////////////////////////////////////
// MAPPER WINDOW STUFF

//////////////////////////////////////////////////////////////////
// Mapper file menu entries
#define ID_MAPPER_FILE_EXPORT       30010
#define ID_MAPPER_FILE_CLOSE        30020

///////////////////////////////////////////////////////////////////
// General application values
#define ID_MAPPER_STATUS_MSG        31000

///////////////////////////////////////////////////////////////////
// MACROS FOR THE CONNECT OF YOUR SIGNALS TO CORRESPONDENT SLOTS 
// IN YOUR MAIN IMPLEMENTATION OF MENUBAR AND TOOLBAR


///////////////////////////////////////////////////////////////////
// MENU CONNECTS
#define CONNECT_CMD(submenu)           connect(submenu, SIGNAL(activated(int)), SLOT(commandCallback(int)));connect(submenu,SIGNAL(highlighted(int)), SLOT(statusCallback(int)))


///////////////////////////////////////////////////////////////////
// TOOLBAR CONNECT  
#define CONNECT_TOOLBAR(ToolBar)        connect(ToolBar, SIGNAL(clicked(int)), SLOT(commandCallback(int)));connect(ToolBar, SIGNAL(highlighted(int,bool)), SLOT(statusCallback(int)))

///////////////////////////////////////////////////////////////////
// Create cases for entries and connect them with their functions
#define ON_CMD(id, cmd_class_function)   case id:cmd_class_function ;break;

///////////////////////////////////////////////////////////////////
// Create cases for entries and connect them to change statusBar entry
#define ON_STATUS_MSG(id, message)     case id:  slotStatusHelpMsg(message);break;

#endif // RESOURCE_H
























